Index: /liacs/SCA2010/BDD/Makefile
===================================================================
--- /liacs/SCA2010/BDD/Makefile	(revision 121)
+++ /liacs/SCA2010/BDD/Makefile	(revision 121)
@@ -0,0 +1,23 @@
+# Rick van der Zwet
+# 0433373
+# XXX Assignment XXX
+# Licence: BSD
+# $Id: Makefile 741 2009-08-05 19:26:23Z rick $
+
+include latex.mk
+
+CFLAGS+=-Wall -g
+PROGRAMS=XXX
+
+all: $(PROGRAMS)
+
+clean: doc-clean
+	rm -Rf $(PROGRAMS)
+
+distclean: doc-distclean
+
+debug:
+	@sh -c 'while [ "true" ]; do make clean && make && ./${PROGRAMS}; echo -n "Completed: "; date; sleep 5; done'
+
+ones: $(PROGRAMS)
+	@sh -c ./$(PROGRAMS)
Index: /liacs/SCA2010/BDD/latex.mk
===================================================================
--- /liacs/SCA2010/BDD/latex.mk	(revision 121)
+++ /liacs/SCA2010/BDD/latex.mk	(revision 121)
@@ -0,0 +1,61 @@
+# Rick van der Zwet <rick@wzoeterwoude.net>
+# Licence: BSD
+# Descrip: LaTex file parser
+# $Id: latex.mk 571 2008-04-20 17:31:04Z rick $
+
+TARGET = report
+LATEX = latex
+XDVI = xdvi
+TEX = latex -halt-on-error
+DVIPDF = dvipdf
+ASPELL = aspell
+ASPELL_ARGS = -c --mode=tex -x
+
+#XXX: Make me dynamic
+VIEWPDF = evince
+.SUFFIXES: .pdf
+
+help:
+	@echo "Usage Makefile <option>"
+
+doc-all: doc-distclean buildpdf
+
+view: viewpdf
+
+viewdvi: builddvi
+	$(XDVI) $(TARGET)
+
+builddvi: $(SOURCE) $(TARGET).dvi
+
+doc-clean:
+	rm -vf *.aux *.log *toc *.out *.bak *.m.tex
+
+doc-distclean: doc-clean
+	rm -vf $(TARGET).dvi $(TARGET).pdf $(PROGRAM)
+
+buildpdf: $(SOURCE) $(TARGET).pdf
+
+viewpdf: buildpdf
+	$(VIEWPDF) $(TARGET).pdf
+
+spell: spell-en
+
+spell-nl: $(TARGET).tex
+	$(ASPELL) -l nl -p ~/aspell-n.dic $(ASPELL_ARGS) $<
+
+spell-en: $(TARGET).tex
+	$(ASPELL) -l en -p ~/aspell-en.dic $(ASPELL_ARGS) $<
+
+.dvi.pdf:
+	$(DVIPDF) $? $@
+
+.tex.dvi:
+	$(TEX) $? $@
+	$(TEX) $? $@
+
+.gs.png:
+	$(GNUPLOT) $?
+
+%.m.tex: %.m
+	highlight --include-style --linenumbers --no-doc \
+	  --latex --input $< --output $@
Index: /liacs/SCA2010/BDD/report.tex
===================================================================
--- /liacs/SCA2010/BDD/report.tex	(revision 121)
+++ /liacs/SCA2010/BDD/report.tex	(revision 121)
@@ -0,0 +1,60 @@
+%
+% $Id: report.tex 571 2008-04-20 17:31:04Z rick $
+%
+
+\documentclass[12pt,a4paper]{article}
+
+\frenchspacing
+\usepackage[english,dutch]{babel}
+\selectlanguage{dutch}
+\usepackage{graphicx}
+\usepackage{url}
+\usepackage{multicol}
+\usepackage{fancybox}
+\usepackage{amssymb,amsmath}
+
+\author{Rick van der Zwet, Universiteit Leiden}
+\title{XXX \\
+\large{XXX}}
+\author{Rick van der Zwet\\
+  \texttt{<hvdzwet@liacs.nl>}\\
+  \\
+  LIACS\\
+  Leiden University\\
+  Niels Bohrweg 1\\
+  2333 CA Leiden\\
+  The Netherlands}
+\date{\today}
+
+\begin{document}
+
+\maketitle
+
+\section{Inleiding}
+\section{Uitleg probleem}
+\section{Theorie}
+\section{Aanpak}
+\section{Implementatie}
+\section{Experimenten}
+\section{Conclusie}
+\begin{thebibliography}{10}
+\end{thebibliography}
+\newpage
+% \advance\textwidth by 8cm
+% \advance\oddsidemargin by -3cm
+% \advance\evensidemargin by -3cm
+% \advance\topmargin by -2cm
+% \advance\textheight by 4cm
+% \advance\footskip by -4cm
+% \marginparwidth 0cm
+% \twocolumn
+% \section*{Appendix}
+% De NN code en pre-parse.pl code  zagen er als volgt uit:
+% \newline
+% \tiny
+% %preformatted with `source-highlight -n -f latex bridge.cc`
+% \input{nn.c}
+% \input{data/pre-parse.pl}
+% \onecolumn
+
+\end{document}
Index: /liacs/SCA2010/nQueens/Makefile
===================================================================
--- /liacs/SCA2010/nQueens/Makefile	(revision 121)
+++ /liacs/SCA2010/nQueens/Makefile	(revision 121)
@@ -0,0 +1,23 @@
+# Rick van der Zwet
+# 0433373
+# XXX Assignment XXX
+# Licence: BSD
+# $Id: Makefile 741 2009-08-05 19:26:23Z rick $
+
+include latex.mk
+
+CFLAGS+=-Wall -g
+PROGRAMS=XXX
+
+all: $(PROGRAMS)
+
+clean: doc-clean
+	rm -Rf $(PROGRAMS)
+
+distclean: doc-distclean
+
+debug:
+	@sh -c 'while [ "true" ]; do make clean && make && ./${PROGRAMS}; echo -n "Completed: "; date; sleep 5; done'
+
+ones: $(PROGRAMS)
+	@sh -c ./$(PROGRAMS)
Index: /liacs/SCA2010/nQueens/latex.mk
===================================================================
--- /liacs/SCA2010/nQueens/latex.mk	(revision 121)
+++ /liacs/SCA2010/nQueens/latex.mk	(revision 121)
@@ -0,0 +1,61 @@
+# Rick van der Zwet <rick@wzoeterwoude.net>
+# Licence: BSD
+# Descrip: LaTex file parser
+# $Id: latex.mk 571 2008-04-20 17:31:04Z rick $
+
+TARGET = report
+LATEX = latex
+XDVI = xdvi
+TEX = latex -halt-on-error
+DVIPDF = dvipdf
+ASPELL = aspell
+ASPELL_ARGS = -c --mode=tex -x
+
+#XXX: Make me dynamic
+VIEWPDF = evince
+.SUFFIXES: .pdf
+
+help:
+	@echo "Usage Makefile <option>"
+
+doc-all: doc-distclean buildpdf
+
+view: viewpdf
+
+viewdvi: builddvi
+	$(XDVI) $(TARGET)
+
+builddvi: $(SOURCE) $(TARGET).dvi
+
+doc-clean:
+	rm -vf *.aux *.log *toc *.out *.bak *.m.tex
+
+doc-distclean: doc-clean
+	rm -vf $(TARGET).dvi $(TARGET).pdf $(PROGRAM)
+
+buildpdf: $(SOURCE) $(TARGET).pdf
+
+viewpdf: buildpdf
+	$(VIEWPDF) $(TARGET).pdf
+
+spell: spell-en
+
+spell-nl: $(TARGET).tex
+	$(ASPELL) -l nl -p ~/aspell-n.dic $(ASPELL_ARGS) $<
+
+spell-en: $(TARGET).tex
+	$(ASPELL) -l en -p ~/aspell-en.dic $(ASPELL_ARGS) $<
+
+.dvi.pdf:
+	$(DVIPDF) $? $@
+
+.tex.dvi:
+	$(TEX) $? $@
+	$(TEX) $? $@
+
+.gs.png:
+	$(GNUPLOT) $?
+
+%.m.tex: %.m
+	highlight --include-style --linenumbers --no-doc \
+	  --latex --input $< --output $@
Index: /liacs/SCA2010/nQueens/report.tex
===================================================================
--- /liacs/SCA2010/nQueens/report.tex	(revision 121)
+++ /liacs/SCA2010/nQueens/report.tex	(revision 121)
@@ -0,0 +1,60 @@
+%
+% $Id: report.tex 571 2008-04-20 17:31:04Z rick $
+%
+
+\documentclass[12pt,a4paper]{article}
+
+\frenchspacing
+\usepackage[english,dutch]{babel}
+\selectlanguage{dutch}
+\usepackage{graphicx}
+\usepackage{url}
+\usepackage{multicol}
+\usepackage{fancybox}
+\usepackage{amssymb,amsmath}
+
+\author{Rick van der Zwet, Universiteit Leiden}
+\title{XXX \\
+\large{XXX}}
+\author{Rick van der Zwet\\
+  \texttt{<hvdzwet@liacs.nl>}\\
+  \\
+  LIACS\\
+  Leiden University\\
+  Niels Bohrweg 1\\
+  2333 CA Leiden\\
+  The Netherlands}
+\date{\today}
+
+\begin{document}
+
+\maketitle
+
+\section{Inleiding}
+\section{Uitleg probleem}
+\section{Theorie}
+\section{Aanpak}
+\section{Implementatie}
+\section{Experimenten}
+\section{Conclusie}
+\begin{thebibliography}{10}
+\end{thebibliography}
+\newpage
+% \advance\textwidth by 8cm
+% \advance\oddsidemargin by -3cm
+% \advance\evensidemargin by -3cm
+% \advance\topmargin by -2cm
+% \advance\textheight by 4cm
+% \advance\footskip by -4cm
+% \marginparwidth 0cm
+% \twocolumn
+% \section*{Appendix}
+% De NN code en pre-parse.pl code  zagen er als volgt uit:
+% \newline
+% \tiny
+% %preformatted with `source-highlight -n -f latex bridge.cc`
+% \input{nn.c}
+% \input{data/pre-parse.pl}
+% \onecolumn
+
+\end{document}