Index: /liacs/SCA2010/BDD/report.tex
===================================================================
--- /liacs/SCA2010/BDD/report.tex	(revision 138)
+++ /liacs/SCA2010/BDD/report.tex	(revision 139)
@@ -159,10 +159,10 @@
 maken van formule~\ref{melt-eq}. Let wel op dat dit voorbeeld geen ontbrekende
 laag van nodes heeft, waardoor nodes van alle niveaus beschikbaar zijn. Op het
-moment dat de $\diamond$ ingevult gaat worden is het ook zaak om de bladeren
+moment dat de $\diamond$ ingevuld gaat worden is het ook zaak om de bladeren
 (zie vergelijking~\ref{bladeren}) te vereenvoudigen} \end{figure}
 
 \section{Introductie BDD}
 Synthese van een Binary Decision Diagram \emph{BDD} is het belangrijke
-\emph{BDD} algoritme~\cite[pp 86]{DK2009}. Welke in essentie een \emph{BDD}
+\emph{BDD} algoritme~\cite[pg 86]{DK2009}. Welke in essentie een \emph{BDD}
 functie,$f$, pakt en deze combineert met een andere \emph{BDD} functie,$g$,
 zodanig dat er een nieuwe \emph{BDD} ontstaat voor de nieuwe functie.
@@ -177,15 +177,15 @@
 \label{werking}
 De term voor het samenvoegen \emph{BDD} structuren zullen we smelten
-(\emph{melding}) noemen. Er werkt volgens de volgende principies.  Men neme
+(\emph{melding}) noemen. Er werkt volgens de volgende principes.  Men neme
 $\alpha = (v,l,h)"$ en $\alpha' = (v',l',h')$. De $\alpha \diamond \alpha'$, de
 "\emph{emulsie}" (\emph{meld}) van $\alpha$ en $\alpha'$, is dan als volgt
-gedefineerd als $\alpha$ ad $\alpha'$ niet beiden bladeren (\emph{sinks}) zijn:
+gedefinieerd als $\alpha$ ad $\alpha'$ niet beiden bladeren (\emph{sinks}) zijn:
 \begin{equation}
 \label{melt-eq}
 \alpha \diamond \alpha' = \left\{
 \begin{array}{l l}
-(v, l \diamond l'), h \diamond h'), & \mathrm{if~} v = v'; \\
-(v, l \diamond \alpha'), h \diamond \alpha'), & \mathrm{if~} v < v'; \\
-(v, \alpha \diamond l'), \alpha \diamond h'), & \mathrm{if~} v > v'. \\
+(v, l \diamond l'), h \diamond h'), & \mathrm{als~} v = v'; \\
+(v, l \diamond \alpha'), h \diamond \alpha'), & \mathrm{als~} v < v'; \\
+(v, \alpha \diamond l'), \alpha \diamond h'), & \mathrm{als~} v > v'. \\
 \end{array} \right.
 \end{equation}
@@ -202,5 +202,5 @@
 Om er weer een 'valide' \emph{BDD} van te maken zullen deze bladeren vervangen
 worden door het uitgerekende blad. Als bijvoorbeeld de $\diamond$ operatie een
-$EN$ operatie was, wordt de bladrij in~\ref{bladeren} vervangen door de rij
+$EN$ operatie was, wordt de blad-rij in~\ref{bladeren} vervangen door de rij
 $\bot, \bot, \bot, \top$. Nu is het zaak de \emph{BDD} te vereenvoudigen, om zo
 duplicaat bladeren te snoeien (\emph{pruning}).
@@ -216,5 +216,5 @@
 Deze grenzen worden in voorbeeld~\ref{voorbeeldSamenvoegen} aangescherpt.
 
-Het smelten ligt aan de basis van de daarwerkelijke synthese. Een simpele
+Het smelten ligt aan de basis van de daadwerkelijke synthese. Een simpele
 variant kan gemaakt worden met algoritme $R$. Maak eerst een reeks van
 alle knopen $\alpha$ in $B(f)$ en $\alpha'$ in $B(g)$ met knoop $\alpha
@@ -226,9 +226,9 @@
 
 Deze 'truc' zorgt ervoor dat de tijd binnen de perken blijft, maar er is dan
-nog niets gezegt over de hoeveelheid geheugen er nodig is. Omdat er nu
+nog niets gezegd over de hoeveelheid geheugen er nodig is. Omdat er nu
 $B(f)B(g)$ knopen in geheugen gehouden moet wordt zal dit problemen opleveren
-bij kleine en grotere algoritmen. Om deze ineffientie aan te pakken is
+bij kleine en grotere algoritmen. Om deze efficiÃ«ntie aan te pakken is
 algoritme $S$ \footnote{Algoritme $S$ wordt niet in deze samenvatting gehandeld
-de vakwebsite~\cite{SCA2010} heeft een verwijzing van de samenvatting van dit
+de vak-website~\cite{SCA2010} heeft een verwijzing van de samenvatting van dit
 algoritme} ontworpen.
 
@@ -251,5 +251,5 @@
 kunnen worden van de functies $f$ en $g$.  
 
-Elke bead van de orde $n - j$ van het geoordende paar $(f,g)$ zal binnen de
+Elke bead van de orde $n - j$ van het geordende paar $(f,g)$ zal binnen de
 standaard combinatie vallen de $b_{j}b_{j}'$ geordende beats van $(f,g)$.
 vallen of is er eentje uit een meer speciaal gegenereerde reeks van een
@@ -290,9 +290,9 @@
 = q$. waar $0 \leq p, q \le 2^m$ en $p=q$ dan en slechts als $x_1 = x_3 = \dots
 = 2_{2m-1} = 0$.  Dit zorgt dat  het eerste deel -het stuk voor de punt
-comma- van het profiel van $f \land g$ geschreven kan worden als $(1, 2, 4,\dots,
+komma- van het profiel van $f \land g$ geschreven kan worden als $(1, 2, 4,\dots,
 2^{2m-2}, 2^{2m-1} - 2^{m-1}$.
-Het tweede deel is aanzienlijk moeilijker, welke bestaat uit de subfuncties
+Het tweede deel is aanzienlijk moeilijker, welke bestaat uit de sub-functies
 $x_{2m+j} \land \overline x_{2m+k}$ of $\overline x_{2m+j} \land x_{2m+k}$ voor
-$1 \leq j \le k \leq 2^m$ tesamen met de orginelen $x_{2m+j}$ en $\overline
+$1 \leq j \le k \leq 2^m$ tezamen met de originelen $x_{2m+j}$ en $\overline
 x_{2m+j}$ voor $2 \leq j \leq 2^m$. Welke het profiel oplevert van $(2^{m+1}-2,
 2^{m+1}-2, 2^{m+1}-4, 2^{m+1}-6, \dots, 4, 2, 2)$.