Index: liacs/SCA2010/nQueens/report.tex
===================================================================
--- liacs/SCA2010/nQueens/report.tex	(revision 143)
+++ liacs/SCA2010/nQueens/report.tex	(revision 144)
@@ -18,5 +18,5 @@
 \floatname{algoritm}{Algoritme}
 
-\title{\emph{n-Queens} minimale dominatie verzamelingen \\
+\title{\emph{n-Queens} minimale dominantie verzamelingen \\
 \large{Chessboard Domination on Programmable Graphics Hardware door Nathan Cournik}}
 \author{Rick van der Zwet\\
@@ -42,15 +42,15 @@
   \label{fig:patroon}
 \end{figure}
-Vanwege het het feit dat \emph{n-Queens} een algemeen geaccepteerde termiologie
+Vanwege het het feit dat \emph{n-Queens} een algemeen geaccepteerde terminologie
 is, voor het plaatsen van $n$ koningen op een $n*n$ schaakbord zodanig dat de
 koningen elkaar niet kunnen slaan, zal dit in het schrijven niet vertaald
-worden. Verder zal in de tekst op diverse plekken de orginele engelse bewoordinging
-staan om zo terugzoeken en refereren in het orginele paper~\cite{CDGPU2006}
+worden. Verder zal in de tekst op diverse plekken de originele Engelse bewoording
+staan om zo terugzoeken en refereren in het originele paper~\cite{CDGPU2006}
 makkelijker te maken.
 
 
-\section{Minimale dominatie verzameling}
-De minimale dominatie verzameling ({\emph{Minimum domination set}}) is
-een setup waarbij zo weinig mogelijk koninginnen wordt gembruikt om elk vakje
+\section{Minimale dominantie verzameling}
+De minimale dominantie verzameling ({\emph{Minimum domination set}}) is
+een opstelling waarbij zo weinig mogelijk koninginnen wordt gebruikt om elk vakje
 van het schaakbord door ten minste 1 koningin geslagen kan worden of dat er een
 koningin op staat. Omdat een koningin een karakteristiek patroon kan staan (zie
@@ -61,6 +61,6 @@
 \label{eq:ondergrens}
 \end{equation}
-Als het een 'gewone' dominatie verzameling is dan hoeft het aantal koninginnen
-niet per-se minimaal zijn.
+Als het een 'gewone' dominantie verzameling is dan hoeft het aantal koninginnen
+niet perse minimaal zijn.
 
 
@@ -69,7 +69,7 @@
   \centering
   \includegraphics[width=0.4\textwidth]{pasted1.png}
-  \caption{\emph{GPU} werking. De verschillende \emph{GPU} processorblokken
+  \caption{\emph{GPU} werking. De verschillende \emph{GPU} processor-blokken
 worden \emph{kernels} genoemd. De data wordt getransporteerd door verschillende
-datakanalen (\emph{streams}) en heeft de vorm van een \emph{framebuffer}, welke
+data-kanalen (\emph{streams}) en heeft de vorm van een \emph{framebuffer}, welke
 intern als $n * m$ array gezien kan worden. Een \emph{kernel} kan toegepast
 worden om een (deel van de) \emph{framebuffer}.} 
@@ -79,10 +79,10 @@
 \emph{GPU}) heeft speciale electronica om ervoor te zorgen dat deze snel de
 \emph{RGB} waardes van alle beeldpunten kan berekenen in complexe beeldsystemen
-met bijvoorbeeld ingewikkende (lees: tijdrovende) berekeningen voor schaduw,
-reflextie en intensiteit. Om deze grote hoeveelheid gegevens te verwerken maakt
-de \emph{GPU} gebruik een grote hoeveelheid parralelle processoren, welke alle
+met bijvoorbeeld ingewikkelde (lees: tijdrovende) berekeningen voor schaduw,
+reflectie en intensiteit. Om deze grote hoeveelheid gegevens te verwerken maakt
+de \emph{GPU} gebruik een grote hoeveelheid parallelle processoren, welke alle
 individueel een deel van de berekeningen op zich nemen.
 
-Recente (electronica) onwikkelingen zoals \emph{CUDA}\footnote{\url{http://en.wikipedia.org/wiki/CUDA}} en (meer generieke implementaties)
+Recente (elektronica) ontwikkelingen zoals \emph{CUDA}\footnote{\url{http://en.wikipedia.org/wiki/CUDA}} en (meer generieke implementaties)
 \emph{OpenCL}\footnote{\url{http://en.wikipedia.org/wiki/OpenCL}} hebben ertoe
 geleid dat de GPU ook door de geprogrammeerd kan worden om specifieke
@@ -92,16 +92,16 @@
 (dus) zeer kleine buffers en instructie set heeft. Verder is het ook cruciaal
 te weten dat de \emph{GPU} \textit{niet} direct gebruik gebruik kan maken van
-het hoofdgeheugen van de \emph{CPU}, maak dat de invoer en uitvoer altijd eerst
+het hoofd-geheugen van de \emph{CPU}, maak dat de invoer en uitvoer altijd eerst
 naar/van de \emph{GPU} verplaatst zal moeten worden.
 
 \section{Aanpak}
-Het zoeken van geldige minimale dominatie verzamelingen is een stevige klus,
+Het zoeken van geldige minimale dominantie verzamelingen is een stevige klus,
 welke we (in het optimale geval) $n$ koninginnen hebben die we op een $n * n$
 schaakbord kunnen plaatsen. Dat levert $(n * n)! - ((n * n)-n)!$ mogelijkheden op.
 De \emph{GPU} zal gebruikt worden om oplossingen sneller te controleren en zal
-niet gebruikt worden om effientere oplossingen te vinden. De kracht zit hem in
+niet gebruikt worden om effici"{e}ntie oplossingen te vinden. De kracht zit hem in
 het feit dat meer oplossingen getest kunnen worden en dus potentieel betere
 oplossingen tussen kunnen zitten, welke ook te zien in in
-algoritme~\ref{alg:overzicht}. De genereerde potentieele oplossingen die aan de
+algoritme~\ref{alg:overzicht}. De genereerde potenti"{e}le oplossingen die aan de
 \emph{GPU} ter controle aangeboden worden respecteren de boven- en ondergrens.
 
@@ -110,5 +110,5 @@
 01: klaar=nee
 02: doe
-03: ..bereken potentieel minimale dominatie verzamelingen
+03: ..bereken potentieel minimale dominantie verzamelingen
 04: ..plaats in framebuffer
 05: ..als (alle pixels zijn gemarkeerd) dan
@@ -116,5 +116,5 @@
 08: totdat (klaar=ja)
 \end{verbatim}
-\caption{evalueren minimale dominatie set}
+\caption{evalueren minimale dominantie set}
 \label{alg:overzicht}
 \end{algoritm}
@@ -130,5 +130,5 @@
 eigenschap waar een \emph{GPU} in uitblinkt; het '\emph{stempelen}' van objecten in
 een raster (welke in traditionele beeldbewerking gebruikt wordt om texturen te
-maken). Elk schaakstuk heeft zijn eigen stempelpatroon zoals te zien in
+maken). Elk schaakstuk heeft zijn eigen stempel-patroon zoals te zien in
 figuur~\ref{fig:stempels}. Hierbij moet opgemerkt worden dat de stempels
 allemaal op hun eigen manier schalen.
@@ -138,8 +138,8 @@
     \includegraphics[width=0.4\textwidth]{pasted5.pdf}
   \end{center}
-  \caption{Door slim te coderen kunnen meerdere potentiele oplossingen tegelijk
+  \caption{Door slim te coderen kunnen meerdere potenti"{e}le oplossingen tegelijk
 bekeken worden. Hier wordt gebruik gemaakt van (a) het feit dat de ruimte groter
 is dan het 'schaakbord' welke bekeken wordt en (b) een pixel gecodeerd is uit
-vier onafhankele kleuren} 
+vier onafhankelijke kleuren} 
   \label{fig:raster}
 \end{figure}
@@ -147,11 +147,11 @@
 gemaakt wordt, namelijk kleur en het verschil in grootte van het bord en de
 geaccepteerde invoer. Door slim te combineren ---zie figuur~\ref{fig:raster}---
-kan het aantal potentiele oplossingen die getest kan worden gemaximaliseerd
+kan het aantal potenti"{e}le oplossingen die getest kan worden gemaximaliseerd
 worden.
 
-De individule \emph{kernels} volgen het algoritme~\ref{alg:kernel}, de test of
+De individuele \emph{kernels} volgen het algoritme~\ref{alg:kernel}, de test of
 alle punten gemarkeerd zijn lijkt om het eerste gezicht een lus en test over
 alle beeldpunten, echter de \emph{GPU} heeft specifieke instructies om dit
-effienter uit te voeren.
+effici"{e}ntie uit te voeren.
 Voor het plaatsen van de stempels moet er gegaan worden voor de grafische
 equivalent van een \texttt{OF} operatie. Als een \texttt{INVERSE} operatie gebruikt zou
@@ -166,5 +166,5 @@
 04: ..oplossing=ja
 \end{verbatim}
-\caption{evalueren minimale dominatie set door individuele kernel}
+\caption{evalueren minimale dominantie set door individuele kernel}
 \label{alg:kernel}
 \end{algoritm}
@@ -175,10 +175,10 @@
   \includegraphics[width=0.4\textwidth]{pasted6.pdf}
   \caption{
-  Uitvoer tijden (logaritmische schaal) van de \emph{CPU} en \emph{GPU} gebaseerde minimale dominatie implementaties welke $y(Q_{n})$ uitrekenen. Hoe groter $n$ wordt, de beter de \emph{GPU} gaan presteren boven de \emph{CPU}} 
+  Uitvoer tijden (logaritmische schaal) van de \emph{CPU} en \emph{GPU} gebaseerde minimale dominantie implementaties welke $y(Q_{n})$ uitrekenen. Hoe groter $n$ wordt, de beter de \emph{GPU} gaan presteren boven de \emph{CPU}} 
   \label{fig:uitvoertijd}
 \end{figure}
-Door het toepassen van de \emph{GPU} in het \emph{n-Queens} probeem kunnen
-winsten geboekt worden zoals te zien in figuur~\ref{fig:uitvoertijd}\footnote{Gegevens direct uit \cite{CDGPU2006} overgenomen experiment niet opnieuw uitgevoerd}. 
-Het toepassen van \emph{GPU} dominatie textuur technieken technieken lijkt voor dit
+Door het toepassen van de \emph{GPU} in het \emph{n-Queens} probleem kunnen
+winsten geboekt worden zoals te zien in figuur~\ref{fig:uitvoertijd}\footnote{Gegevens direct uit \cite{CDGPU2006} overgenomen, experiment niet opnieuw uitgevoerd}. 
+Het toepassen van \emph{GPU} dominantie textuur technieken technieken lijkt voor dit
 specifieke geval een goede vertaling van de traditionele \emph{CPU} wereld en
 de \emph{GPU} wereld. De stempels bieden tevens meer vrijheden om alternatieve
@@ -186,8 +186,8 @@
 \subsection{Verder werk} 
 Er zal gekeken worden of de generatie van nieuwe oplossingen ook op de
-\emph{GPU} gedaan kan worden om zo het probeem van de langzame context
+\emph{GPU} gedaan kan worden om zo het probleem van de langzame context
 wisselingen op te lossen.
 Verder zal er gekeken worden of de codering van de borden op nog een slimmere
-manier aangepakt kan worden, in plaats van de kleur in 4 basiskleuren uit te
+manier aangepakt kan worden, in plaats van de kleur in 4 basis-kleuren uit te
 splitsen zouden ook de volledige 32 bits (elke kleur is 8 bit) kunnen worden om
 nog meer(combinaties) van oplossingen te coderen.
@@ -197,5 +197,5 @@
 grafieken. Beiden lijken erg dicht bij elkaar te blijven en ik zie niet waarom
 dit plots veel beter zou worden bij grotere $n$ waarden.
-De 'tegelmethode' van figuur~\ref{fig:raster} lijkt in theorie leuk, maar als
+De 'tegel-methode' van figuur~\ref{fig:raster} lijkt in theorie leuk, maar als
 de $n$ groter wordt is er grote kans dat de tegels niet meer (goed) passen. Als
 de $n$ groter wordt dan in mogelijke invoer is het helemaal niet meer mogelijk.